"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.WebpackRecursiveLoader = WebpackRecursiveLoader;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _loaderUtils = require("loader-utils");

var t = _interopRequireWildcard(require("@babel/types"));

var _generator = _interopRequireDefault(require("@babel/generator"));

var _util = require("./util");

var _path = _interopRequireDefault(require("path"));

var _util2 = require("util");

function _createForOfIteratorHelper(o, allowArrayLike) { var it; if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = o[Symbol.iterator](); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function WebpackRecursiveLoader(source) {
  var _getOptions = (0, _loaderUtils.getOptions)(this),
      _getOptions$fileSyste = _getOptions.fileSystem,
      fileSystem = _getOptions$fileSyste === void 0 ? this.fs : _getOptions$fileSyste,
      plugin = _getOptions.plugin,
      root = _getOptions.root,
      dirPath = _getOptions.path;

  var readDirAsync = (0, _util2.promisify)(fileSystem.readdir.bind(fileSystem));
  var statAsync = (0, _util2.promisify)(fileSystem.stat.bind(fileSystem));
  var callback = this.async();
  (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2() {
    var _context;

    var absDirPath, entries, dependencies, keys, body, _iterator, _step, entry, type, basename, path, absPath, file, name, filePath, _toQueryString, query, _context3, hot, ast;

    return _regenerator["default"].wrap(function _callee2$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            absDirPath = _path["default"].join(root, dirPath);
            _context4.next = 3;
            return readDirAsync(absDirPath);

          case 3:
            entries = _context4.sent;
            _context4.next = 6;
            return Promise.all((_context = entries, _util.map).call(_context, /*#__PURE__*/function () {
              var _ref2 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee(entry) {
                var stats;
                return _regenerator["default"].wrap(function _callee$(_context2) {
                  while (1) {
                    switch (_context2.prev = _context2.next) {
                      case 0:
                        _context2.next = 2;
                        return statAsync(_path["default"].join(absDirPath, entry));

                      case 2:
                        stats = _context2.sent;
                        stats.name = entry;
                        return _context2.abrupt("return", stats);

                      case 5:
                      case "end":
                        return _context2.stop();
                    }
                  }
                }, _callee);
              }));

              return function (_x) {
                return _ref2.apply(this, arguments);
              };
            }()));

          case 6:
            entries = _context4.sent;
            dependencies = [];
            keys = new Map();
            body = [];
            _iterator = _createForOfIteratorHelper(entries);
            _context4.prev = 11;

            _iterator.s();

          case 13:
            if ((_step = _iterator.n()).done) {
              _context4.next = 41;
              break;
            }

            entry = _step.value;
            type = void 0;

            if (!entry.isFile()) {
              _context4.next = 20;
              break;
            }

            type = 'file';
            _context4.next = 25;
            break;

          case 20:
            if (!entry.isDirectory()) {
              _context4.next = 24;
              break;
            }

            type = 'directory';
            _context4.next = 25;
            break;

          case 24:
            return _context4.abrupt("continue", 39);

          case 25:
            basename = entry.name;
            path = _path["default"].join(dirPath, basename);
            absPath = _path["default"].join(root, path);
            file = {
              basename: basename,
              path: path,
              absPath: absPath,
              type: type
            };
            name = plugin._getNameForFile(file);

            if (!(name == null)) {
              _context4.next = 32;
              break;
            }

            return _context4.abrupt("continue", 39);

          case 32:
            filePath = absPath;

            if (type === 'directory') {
              query = (0, _util.toQueryString)((_toQueryString = {}, (0, _defineProperty2["default"])(_toQueryString, plugin.keyword, plugin.namespace), (0, _defineProperty2["default"])(_toQueryString, "root", root), _toQueryString));
              filePath = "".concat(filePath, "?").concat(query);
            }

            dependencies.push(filePath);

            if (!keys.has(name)) {
              _context4.next = 37;
              break;
            }

            throw new Error("Naming conflict for name '".concat(name, "':\n").concat(path, "\n").concat(keys.get(name)));

          case 37:
            keys.set(name, path); //add import statement

            body.push(t.importDeclaration([t.importNamespaceSpecifier(t.identifier(name))], t.stringLiteral(filePath)));

          case 39:
            _context4.next = 13;
            break;

          case 41:
            _context4.next = 46;
            break;

          case 43:
            _context4.prev = 43;
            _context4.t0 = _context4["catch"](11);

            _iterator.e(_context4.t0);

          case 46:
            _context4.prev = 46;

            _iterator.f();

            return _context4.finish(46);

          case 49:
            //export all the keys
            if (keys.size > 0) {
              body.push(t.exportNamedDeclaration(null, (0, _toConsumableArray2["default"])((_context3 = keys.keys(), _util.map).call(_context3, function (key) {
                key = t.identifier(key);
                return t.exportSpecifier(key, key);
              }))));
            } //add hot reload support


            hot = t.memberExpression(t.identifier('module'), t.identifier('hot'));
            body.push(t.ifStatement(hot, t.blockStatement([t.expressionStatement(t.callExpression(t.memberExpression(hot, t.identifier('accept')), [t.arrayExpression((0, _toConsumableArray2["default"])(_util.map.call(dependencies, function (dep) {
              return t.stringLiteral(dep);
            })))]))])));
            ast = t.program(body, [], 'module');
            source = (0, _generator["default"])(ast).code;
            console.log(source);
            callback(null, source);

          case 56:
          case "end":
            return _context4.stop();
        }
      }
    }, _callee2, null, [[11, 43, 46, 49]]);
  }))()["catch"](function (err) {
    return callback(err);
  });
}
//# sourceMappingURL=loader.js.map