"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.map = map;
exports.filter = filter;
exports.keys = keys;
exports.entries = entries;
exports.join = join;
exports.toQueryString = toQueryString;
exports.fromQueryString = fromQueryString;
exports.cacheDecorator = cacheDecorator;

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _marked = /*#__PURE__*/_regenerator["default"].mark(map),
    _marked2 = /*#__PURE__*/_regenerator["default"].mark(filter),
    _marked3 = /*#__PURE__*/_regenerator["default"].mark(keys),
    _marked4 = /*#__PURE__*/_regenerator["default"].mark(entries);

function _createForOfIteratorHelper(o, allowArrayLike) { var it; if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = o[Symbol.iterator](); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function map(func) {
  var i, _iterator, _step, value;

  return _regenerator["default"].wrap(function map$(_context) {
    while (1) {
      switch (_context.prev = _context.next) {
        case 0:
          i = 0;
          _iterator = _createForOfIteratorHelper(this);
          _context.prev = 2;

          _iterator.s();

        case 4:
          if ((_step = _iterator.n()).done) {
            _context.next = 10;
            break;
          }

          value = _step.value;
          _context.next = 8;
          return func.call(this, value, i++);

        case 8:
          _context.next = 4;
          break;

        case 10:
          _context.next = 15;
          break;

        case 12:
          _context.prev = 12;
          _context.t0 = _context["catch"](2);

          _iterator.e(_context.t0);

        case 15:
          _context.prev = 15;

          _iterator.f();

          return _context.finish(15);

        case 18:
        case "end":
          return _context.stop();
      }
    }
  }, _marked, this, [[2, 12, 15, 18]]);
}

function filter(func) {
  var i, _iterator2, _step2, value;

  return _regenerator["default"].wrap(function filter$(_context2) {
    while (1) {
      switch (_context2.prev = _context2.next) {
        case 0:
          i = 0;
          _iterator2 = _createForOfIteratorHelper(this);
          _context2.prev = 2;

          _iterator2.s();

        case 4:
          if ((_step2 = _iterator2.n()).done) {
            _context2.next = 11;
            break;
          }

          value = _step2.value;

          if (!func.call(this, value, i++)) {
            _context2.next = 9;
            break;
          }

          _context2.next = 9;
          return value;

        case 9:
          _context2.next = 4;
          break;

        case 11:
          _context2.next = 16;
          break;

        case 13:
          _context2.prev = 13;
          _context2.t0 = _context2["catch"](2);

          _iterator2.e(_context2.t0);

        case 16:
          _context2.prev = 16;

          _iterator2.f();

          return _context2.finish(16);

        case 19:
        case "end":
          return _context2.stop();
      }
    }
  }, _marked2, this, [[2, 13, 16, 19]]);
}

function keys() {
  var key;
  return _regenerator["default"].wrap(function keys$(_context3) {
    while (1) {
      switch (_context3.prev = _context3.next) {
        case 0:
          _context3.t0 = _regenerator["default"].keys(this);

        case 1:
          if ((_context3.t1 = _context3.t0()).done) {
            _context3.next = 8;
            break;
          }

          key = _context3.t1.value;

          if (!Object.hasOwnProperty.call(this, key)) {
            _context3.next = 6;
            break;
          }

          _context3.next = 6;
          return key;

        case 6:
          _context3.next = 1;
          break;

        case 8:
        case "end":
          return _context3.stop();
      }
    }
  }, _marked3, this);
}

function entries() {
  var _iterator3, _step3, key;

  return _regenerator["default"].wrap(function entries$(_context4) {
    while (1) {
      switch (_context4.prev = _context4.next) {
        case 0:
          _iterator3 = _createForOfIteratorHelper(keys.call(this));
          _context4.prev = 1;

          _iterator3.s();

        case 3:
          if ((_step3 = _iterator3.n()).done) {
            _context4.next = 9;
            break;
          }

          key = _step3.value;
          _context4.next = 7;
          return [key, this[key]];

        case 7:
          _context4.next = 3;
          break;

        case 9:
          _context4.next = 14;
          break;

        case 11:
          _context4.prev = 11;
          _context4.t0 = _context4["catch"](1);

          _iterator3.e(_context4.t0);

        case 14:
          _context4.prev = 14;

          _iterator3.f();

          return _context4.finish(14);

        case 17:
        case "end":
          return _context4.stop();
      }
    }
  }, _marked4, this, [[1, 11, 14, 17]]);
}

function join() {
  var sep = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
  var str = '';
  var i = 0;

  var _iterator4 = _createForOfIteratorHelper(this),
      _step4;

  try {
    for (_iterator4.s(); !(_step4 = _iterator4.n()).done;) {
      var value = _step4.value;
      if (i++ > 0) str += sep;
      str += value;
    }
  } catch (err) {
    _iterator4.e(err);
  } finally {
    _iterator4.f();
  }

  return str;
}

function toQueryString(options) {
  var _context5;

  return (_context5 = (_context5 = (_context5 = entries.call(options), map).call(_context5, function (_ref) {
    var _ref2 = (0, _slicedToArray2["default"])(_ref, 2),
        key = _ref2[0],
        value = _ref2[1];

    var encode = encodeURIComponent;

    if (typeof value === 'string') {
      return "".concat(encode(key), "=").concat(encode(value));
    } else if (typeof value === 'boolean') {
      if (value) return encode(key);else return null;
    } else if (value == null) {
      return null;
    } else {
      throw new Error("Unsupported query string value: ".concat(value));
    }
  }), filter).call(_context5, Boolean), join).call(_context5, '&');
}

function fromQueryString(str) {
  var decode = decodeURIComponent;
  var options = Object.create(null);

  var _iterator5 = _createForOfIteratorHelper(str.split('&')),
      _step5;

  try {
    for (_iterator5.s(); !(_step5 = _iterator5.n()).done;) {
      var part = _step5.value;

      var _part$split = part.split('='),
          _part$split2 = (0, _slicedToArray2["default"])(_part$split, 2),
          key = _part$split2[0],
          value = _part$split2[1];

      key = decode(key);
      value = value == null ? true : decode(value);
      options[key] = value;
    }
  } catch (err) {
    _iterator5.e(err);
  } finally {
    _iterator5.f();
  }

  return options;
}

function cacheDecorator(keyFunc) {
  var cacheKey = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : Symbol('cache');
  return function (func) {
    var wrapper = function wrapper() {
      var cache = this[cacheKey];
      if (cache == null) cache = this[cacheKey] = new Map();
      var key = keyFunc.call.apply(keyFunc, [this].concat(Array.prototype.slice.call(arguments)));
      if (cache.has(key)) return cache.get(key);
      var value = func.call.apply(func, [this].concat(Array.prototype.slice.call(arguments)));
      cache.set(key, value);
      return value;
    }; //copy name, length, etc.


    Object.defineProperties(wrapper, Object.getOwnPropertyDescriptors(func));
    return wrapper;
  };
}
//# sourceMappingURL=util.js.map